import math,random
def array(N1,N2=0):#■配列の宣言
    if N2==0: return [0 for i in range(N1)]
    return [[0 for i in range(N2)]for j in range(N1)]
NUMFREQ=8           #出現素子値組数
NUMNODE=4           #ノード数(しきい値用を含む)
Temp=0.5            #温度
Loop=100            #更新回数
numLP=0             #回数
numID=array(NUMFREQ)#発生回数
P=array(NUMFREQ)    #出現頻度
Q=array(NUMFREQ)    #理論値
X=array(NUMNODE)    #ノードの値
XX=array(NUMNODE)   #ノードの値計算用
W=[[ 0.0,  5.0,  5.0,  5.0], #重み行列
   [ 5.0,  0.0, -2.0, -2.0],
   [ 5.0, -2.0,  0.0, -2.0],
   [ 5.0, -2.0, -2.0,  0.0]]
def sigmoid(z, Temp):#■シグモイド関数
    ZZ = -z/Temp
    if ZZ>=100:return 0.0
    return 1.0 / (1.0 + math.exp(ZZ))
def energy(Pattern):#■エネルギーの計算
  tmp = Pattern
  for i in range(1,NUMNODE):
      XX[i] = tmp % 2; tmp = (tmp-XX[i])/2
  XX[0] = 1; E = 0
  for j in range(NUMNODE):
      for i in range(NUMNODE):E -= W[i][j]*XX[i]*XX[j]/2
  return E
def Boltzmann():#■ボルツマン・マシンの処理
    prSW=True #途中経過のID, X表示
    numLP=0; numID=array(8);X=array(4)#初期化
    X[0] = 1 #しきい値用ノードは常に1
    for Update in range(Loop):#素子値を更新回数だけ更新
        for j in range(1,NUMNODE):#素子値の更新
            NetIn = 0
            for i in range(NUMNODE): NetIn += W[i][j]* X[i]
            Y = sigmoid(NetIn, Temp)
            R = random.random(); X[j] = 0 #Hopfield NNのとき
            #R = 0.5; X[j] = 0  #R=0.5とするか，YをXの値とする
            if R < Y : X[j] = 1 #ただし，出現頻度は無視する。
        ID = 0  #出現素子値組
        for i in range(NUMNODE-1,0,-1):ID = ID * 2 + X[i]
        ID=int(ID)
        if prSW:print("%5d,%2d,X=[%2d,%2d,%2d]"%
                      (Update,ID,X[1],X[2],X[3]))
        numID[ID]+=1 #出現回数の記録
    for i in range(8): P[i] = numID[i]/Update#出現頻度設定
    TotalQ = 0 #理論値の設定
    for i in range(NUMFREQ):
        ZZ = -energy(i)/Temp; Q[i] = math.exp(ZZ)
        TotalQ += Q[i]
    if TotalQ <= 0 :print("理論値を設定できません")
    else:
        for i in range(NUMFREQ): Q[i] /= TotalQ
    #----------以下，表示用-------------------
    print("\n■重み行列")
    for j in range(NUMNODE):
        S=""
        for i in range(NUMNODE): S+="%7.2f"% W[i][j]
        print(S)
    print("\n■出現頻度")
    print("ID 理論値 回数  実際")
    print("--------------------")
    for i in range(NUMFREQ):
        print("%2d%7.2f%4d%7.2f" %(i, Q[i],numID[i],P[i]))
Boltzmann()
